#pragma once
#include <fstream>
#include <vector>
#include <set>
#include <unordered_set>

#include "Struct.h"



class MeshLoader
{
protected:
    std::vector<Node> nodes;
    std::vector<FiniteElement> elements;
    std::vector<BoundaryFiniteElement> boundary;

public:

    virtual void LoadMesh(const std::string&) = 0;
    virtual ~MeshLoader() = default;
    void Print_Data();

    std::vector<Node>& Get_Nodes()
    {
        return nodes;
    }
    std::vector<FiniteElement>& Get_Elements()
    {
        return elements;
    }
    std::vector<BoundaryFiniteElement>& Get_Surfaces()
    {
        return boundary;
    }   
    std::vector<FiniteElement> Get_Elements_by_ID(int id1, int id2, int id3);     
    std::vector<FiniteElement> Get_Elements_by_rib(int id1, int id2);
    std::vector<FiniteElement> Get_Elements_by_ID_area(int a_id);
    std::vector<Node> Get_Vertex_Nodes_by_Border_ID(int s_id);
    std::vector<BoundaryFiniteElement> Get_Borders_by_Border_ID(int s_id);
    void Insert_New_Nodes();
    std::vector<std::set<int>> Get_Nodes_Neighbors();
    Node Get_Node_by_ID(int n_id);
};
